/*
 * Copyright (c) 2015, StrategyQuant - All rights reserved.
 *
 * Code in this file was made in a good faith that it is correct and does what it should. 
 * If you found a bug in this code OR you have an improvement suggestion OR you want to include 
 * your own code snippet into our standard library please contact us at:
 * http://tasks.strategyquant.com/projects/snippets/
 *
 * This code can be used only within StrategyQuant products. 
 * Every owner of valid (free, trial or commercial) license of any StrategyQuant product 
 * is allowed to freely use, copy, modify or make derivative work of this code without limitations,
 * to be used in all StrategyQuant products and share his/her modifications or derivative work 
 * with the StrategyQuant community.
 *  
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, 
 * INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES 
 * OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *  
 */
package com.strategyquant.extend.StatValues;

import com.strategyquant.lib.results.SQOrder;
import com.strategyquant.lib.results.SQOrderList;
import com.strategyquant.lib.results.SQStats;
import com.strategyquant.lib.results.StatValue;
import com.strategyquant.lib.results.StatsConst;
import com.strategyquant.lib.results.StatsTypeCombination;
import com.strategyquant.lib.settings.SQSettings;
import com.strategyquant.lib.utils.SQUtils;

public class ProfitLossValues extends StatValue {
	private double netProfit;
	private double sumProfitsInMoney, sumLossesInMoney;

	@Override
	public void initCompute(SQStats stats, StatsTypeCombination combination, SQOrderList ordersList, SQSettings settings, SQStats statsLong, SQStats statsShort) throws Exception {
		netProfit = 0;
		sumProfitsInMoney = 0;
		sumLossesInMoney = 0;		
	}

	@Override
	public void computeForOrder(SQStats stats, StatsTypeCombination combination, SQOrder order, SQSettings settings, SQStats statsLong, SQStats statsShort) throws Exception {
		
		if(order.isBalanceOrder()) {
			// don'tcount balance orders (deposits, withdrawals) in
			return;
		}

		double PL = getPLByStatsType(order, combination);
		
		netProfit += PL;

		if(order.PL > 0) {
			sumProfitsInMoney += Math.abs(PL);
		} else {
			sumLossesInMoney +=  Math.abs(PL);
		}
	}

	@Override
	public void endCompute(SQStats stats, StatsTypeCombination combination, SQOrderList ordersList, SQSettings settings, SQStats statsLong, SQStats statsShort) throws Exception {

		stats.set(StatsConst.NET_PROFIT, SQUtils.round2(netProfit));
		stats.set(StatsConst.GROSS_PROFIT, SQUtils.round2(sumProfitsInMoney));
		stats.set(StatsConst.GROSS_LOSS, SQUtils.round2(-sumLossesInMoney));
		
		double profitFactor = 0d;
		
        if(sumLossesInMoney == 0) {
            if(ordersList.size() > 10) {
            	profitFactor = 5.0d;
            }
        } else {
        	profitFactor = sumProfitsInMoney / sumLossesInMoney;
        }
        
        stats.set(StatsConst.PROFIT_FACTOR, SQUtils.round2(profitFactor));
	}
}